<?php
    /**
     * Excecoes relacionadas com os itens da solicitacao.
     */

namespace Compras\Logic\SolicitacaoCompras\Exception;

class ProdutoSoli extends \Compras\Logic\Exception
{

    private $messageName;

    /**
     * Construtor.
     *
     * Recebe o nome da mensagem cadastrada no setforms.
     *
     * @param string $messageName
     * @param string $message
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct($messageName, $message = "", $code = 0, \Exception $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->messageName = $messageName;
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Excecao lancada ao tentar excluir o ultimo item da solicitacao.
     *
     * @static
     * @throws ProdutoSoli
     */
    public static function excluiUltimoItemSoli()
    {
        throw new self(
            "msg_exclui_ultimo_item_solicitacao",
            "Operação bloqueada! Para excluir o último item deve-se excluir a solicitação inteira."
        );
    }

}
